--[[
=============================================
Send SMS with your psp using Danzeff keyboard
=============================================
]]

--- Load scripts

dofile("danzeff.lua")
dofile("netlib.lua")
blue = Color.new(0, 0, 255)

--- Keyboard Initialization

keyboard = Danzeff:New()

--- Background of the application

background = Image.load("./background.png")  

--- Field to be edited

pad = Controls.read()

field = "Friends Phone Number (area code,no spaces or dashes)"
field2 = "Your Message"
field3 = "Your phone number"
fieldedit = 1
fieldpos = 1
textcolor = Color.new(0, 0, 0)
selecolor = Color.new(0, 255, 255)
editcolor = Color.new(255, 255, 255)
cursorcolor = Color.new(255, 0, 0)
editmode = false
newchar = 0
tickpad = 0


board = Image.createEmpty(480,272)

oldPad = Controls.read()
olddy = 2
olddx = 2
goprg = true

function DisplayScreen()

  board:clear()
  board:blit(0, 0, background, 0, 0, background:width(), background:height(), false)
  screen:blit(0, 0, board, 0, 0, background:width(), background:height(), false)

  screen:print(100, 60, "X to edit a line, O to select the other line", editcolor)

  if editmode then
    if fieldedit == 1 then
      screen:print(10, 20, field, editcolor)
      screen:print(10, 40, field2, textcolor)
      screen:drawLine(10 + (fieldpos * 8), 28, 10 + ((fieldpos + 1) * 8), 28, cursorcolor)
    else
      screen:print(10, 20, field, textcolor)
      screen:print(10, 40, field2, editcolor)
      screen:drawLine(10 + (fieldpos * 8), 48, 10 + ((fieldpos + 1) * 8), 48, cursorcolor)
    end
  else
    if fieldedit == 1 then
      screen:print(10, 20, field, selecolor)
      screen:print(10, 40, field2, textcolor)
    else
      screen:print(10, 20, field, textcolor)
      screen:print(10, 40, field2, selecolor)
    end
  end
  

end


--- Display screen

DisplayScreen()


screen:waitVblankStart()
screen:flip()

--- Main processing

while goprg do


  --- Read controls

  pad = Controls.read()
 

  dx = 2
  dy = 2

  if pad:analogX() < -42 then dx = 1 end
  if pad:analogX() > 42  then dx = 3 end
  if pad:analogY() < -42 then dy = 1 end
  if pad:analogY() > 42  then dy = 3 end

  if pad:buttons() ~= oldPad:buttons() or dy ~= olddy or dx ~= olddx then
    tickpad = 0 
  else
    tickpad = tickpad + 1
    if tickpad > 2 then tickpad = 0 end
  end
  
  if pad:square()
then

screen:print(10,10,"Connecting...", blue)
netconnect(1)
screen:print(10,70,"Connected!", blue)
screen:print(10,120,"Sending message", blue)
netsms(field,field2)
screen:print(200,200,"Done.", blue)
end
  
  if tickpad == 0 then
    oldPad = pad
    olddx = dx
    olddy = dy
    if editmode then

      --  Read Keyboard Input

      newchar = keyboard:Input(pad)

      --  Keyboard Input red

      if newchar == 4 or newchar == 3 then
        editmode = false
        DisplayScreen()
      elseif newchar == 10 then
        editmode = false
        if fieldedit == 1 then fieldedit = 2 
        else                   fieldedit = 1
        end
        DisplayScreen()
      else
        if fieldedit == 1 then
          newfield = field
        else
          newfield = field2
        end 
        if newchar == 1 then
            if fieldpos > 0 then fieldpos = fieldpos - 1 end
        elseif newchar == 2 then
            if fieldpos < string.len(newfield) then fieldpos = fieldpos + 1 end
        elseif newchar == 8 then
              if fieldpos > 0 then
                newfieldend = string.sub(newfield, fieldpos + 1, string.len(newfield))
                newfieldbeg = string.sub(newfield, 0, fieldpos - 1)
                newfield = newfieldbeg .. newfieldend
                fieldpos = fieldpos - 1
              end
        elseif newchar == 9 then
              if fieldpos < string.len(newfield) then
                newfieldend = string.sub(newfield, fieldpos + 2, string.len(newfield))
                newfieldbeg = string.sub(newfield, 0, fieldpos)
                newfield = newfieldbeg .. newfieldend
              end
        elseif newchar == 0 then
        else
              newfieldend = string.sub(newfield, fieldpos + 1, string.len(newfield))
              newfieldbeg = string.sub(newfield, 0, fieldpos)
              newfield = newfieldbeg .. string.char(newchar) .. newfieldend
              fieldpos = fieldpos + 1
        end
        if fieldedit == 1 then
          field = newfield
        else
          field2 = newfield
        end
        DisplayScreen()
        keyboard:Display()
      end
      screen:waitVblankStart()
      screen:flip()
    else
      if pad:start() then
        goprg = false
      else
        if pad:cross() then
          editmode = true
          if fieldedit == 1 then
            fieldpos = string.len(field)
          else
            fieldpos = string.len(field2)
          end
          DisplayScreen()


          -- Loads the Keyboard

          if fieldedit == 1 then
            keyboard:Init(100, 100)
          else
            keyboard:Init(200, 100)
          end
          
          

          -- Keyboard loaded 

          screen:waitVblankStart()
          screen:flip()
        elseif pad:circle() then
          if fieldedit == 1 then fieldedit = 2 
          else                   fieldedit = 1
          end
          DisplayScreen()
          screen:waitVblankStart()
          screen:flip()
         else
           screen:waitVblankStart()
        end
      end
    end
  else
    screen:waitVblankStart()
  end


end
